//----------------------------------------------------------------------
//							    AIC Driver
//				   Write By Mohammad mazarei @ 1390/7/12
//					Email: mohammad.mazarei@gmail.com
//					    Publish In IranMicro.ir
//----------------------------------------------------------------------
#ifndef AIC_H
#define AIC_H
#include <at91sam7x256.h>
#include <lib_at91sam7x256.h>

/*----------------------------------PIO MACRO --------------------------------------*/
#define AIC_Configure_PIO(AIC_PORT,AIC_PIN)		AIC_PORT->PIO_PDR=(1<<AIC_PIN);AIC_PORT->PIO_MDER=(1<<AIC_PIN);AIC_PORT->PIO_ASR=(1<<AIC_PIN);AIC_PORT->PIO_PPUER=(1<<AIC_PIN)
#define IRQ_ACT_POWER(IRQ_ID)					AT91C_BASE_PMC->PMC_PCER = (1<<IRQ_ID);
#define CALL_END_OF_Interrupt(pAic)				pAic->AIC_EOICR=0				
//---------------------------- INTERRUPTS ID -----------------------------------------
#define AT91C_ID_FIQ    ((unsigned int)  0) // Advanced Interrupt Controller (FIQ)
#define AT91C_ID_SYS    ((unsigned int)  1) // System Peripheral
#define AT91C_ID_PIOA   ((unsigned int)  2) // Parallel IO Controller A
#define AT91C_ID_PIOB   ((unsigned int)  3) // Parallel IO Controller B
#define AT91C_ID_SPI0   ((unsigned int)  4) // Serial Peripheral Interface 0
#define AT91C_ID_SPI1   ((unsigned int)  5) // Serial Peripheral Interface 1
#define AT91C_ID_US0    ((unsigned int)  6) // USART 0
#define AT91C_ID_US1    ((unsigned int)  7) // USART 1
#define AT91C_ID_SSC    ((unsigned int)  8) // Serial Synchronous Controller
#define AT91C_ID_TWI    ((unsigned int)  9) // Two-Wire Interface
#define AT91C_ID_PWMC   ((unsigned int) 10) // PWM Controller
#define AT91C_ID_UDP    ((unsigned int) 11) // USB Device Port
#define AT91C_ID_TC0    ((unsigned int) 12) // Timer Counter 0
#define AT91C_ID_TC1    ((unsigned int) 13) // Timer Counter 1
#define AT91C_ID_TC2    ((unsigned int) 14) // Timer Counter 2
#define AT91C_ID_CAN    ((unsigned int) 15) // Control Area Network Controller
#define AT91C_ID_EMAC   ((unsigned int) 16) // Ethernet MAC
#define AT91C_ID_ADC    ((unsigned int) 17) // Analog-to-Digital Converter
#define AT91C_ID_AES    ((unsigned int) 18) // Advanced Encryption Standard 128-bit
#define AT91C_ID_TDES   ((unsigned int) 19) // Triple Data Encryption Standard
#define AT91C_ID_IRQ0   ((unsigned int) 30) // Advanced Interrupt Controller (IRQ0)
#define AT91C_ID_IRQ1   ((unsigned int) 31) // Advanced Interrupt Controller (IRQ1)
#define AT91C_ALL_INT   ((unsigned int) 0xC00FFFFF) // ALL VALID INTERRUPTS
/*---------------------------------------------------------------------------------------*/
/*-----------------------------------AIC Configure Key ----------------------------------*/
#define 	AIC_PRIOR_LOWEST               ((unsigned int) 0x0) //  Lowest priority level
#define 	AIC_PRIOR_HIGHEST              ((unsigned int) 0x7) // Highest priority level

#define 	AIC_EXT_LOW_LEVEL        ((unsigned int) 0x0 <<  5) //  External Sources Code Label Low-level Sensitive
#define 	AIC_INT_HIGH_LEVEL       ((unsigned int) 0x0 <<  5) //  Internal Sources Code Label High-level Sensitive
#define 	AIC_INT_POSITIVE_EDGE    ((unsigned int) 0x1 <<  5) //  Internal Sources Code Label Positive Edge triggered
#define 	AIC_EXT_NEGATIVE_EDGE    ((unsigned int) 0x1 <<  5) //  External Sources Code Label Negative Edge triggered
#define 	AIC_HIGH_LEVEL           ((unsigned int) 0x2 <<  5) //  Internal Or External Sources Code Label High-level Sensitive
#define 	AIC_POSITIVE_EDGE        ((unsigned int) 0x3 <<  5) //  Internal Or External Sources Code Label Positive Edge triggered

#define 	SAM7X_AIC				  AT91C_BASE_AIC


//*----------------------------------------------------------------------------
//* \fn    AT91F_AIC_ConfigureIt
//* \brief Interrupt Handler Initialization
//*----------------------------------------------------------------------------
__inline unsigned int AT91F_AIC_ConfigureIt (
	AT91PS_AIC pAic,  // \arg pointer to the AIC registers
	unsigned int irq_id,     // \arg interrupt number to initialize
	unsigned int priority,   // \arg priority to give to the interrupt
	unsigned int src_type,   // \arg activation and sense of activation
	void (*newHandler) () ); // \arg address of the interrupt handler

//*----------------------------------------------------------------------------
//* \fn    AT91F_AIC_EnableIt
//* \brief Enable corresponding IT number
//*----------------------------------------------------------------------------
__inline void AT91F_AIC_EnableIt (
	AT91PS_AIC pAic,      // \arg pointer to the AIC registers
	unsigned int irq_id ); // \arg interrupt number to initialize

//*----------------------------------------------------------------------------
//* \fn    AT91F_AIC_DisableIt
//* \brief Disable corresponding IT number
//*----------------------------------------------------------------------------
__inline void AT91F_AIC_DisableIt (
	AT91PS_AIC pAic,      // \arg pointer to the AIC registers
	unsigned int irq_id ); // \arg interrupt number to initialize

//*----------------------------------------------------------------------------
//* \fn    AT91F_AIC_ClearIt
//* \brief Clear corresponding IT number
//* Clear the interrupt on the Interrupt Controller ( if one is pending )
//*----------------------------------------------------------------------------
__inline void AT91F_AIC_ClearIt (
	AT91PS_AIC pAic,     // \arg pointer to the AIC registers
	unsigned int irq_id); // \arg interrupt number to initialize


//*----------------------------------------------------------------------------
//* \fn    AT91F_AIC_IsActive
//* \brief Test if an IT is active
//*----------------------------------------------------------------------------
__inline unsigned int  AT91F_AIC_IsActive (
	AT91PS_AIC pAic,     // \arg pointer to the AIC registers
	unsigned int irq_id); // \arg Interrupt Number

//*----------------------------------------------------------------------------
//* \fn    AT91F_AIC_IsPending
//* \brief Test if an IT is pending
//*----------------------------------------------------------------------------
__inline unsigned int  AT91F_AIC_IsPending (
	AT91PS_AIC pAic,     // \arg pointer to the AIC registers
	unsigned int irq_id); // \arg Interrupt Number

#endif //#ifndef AIC_H

